## mingw-w64-python-cx-freeze-8.3.0-2.src.tar.zst

=== Makefile ===
# Makefile to automate some tools
SHELL=/bin/bash
PATH := $(shell python -c "import sysconfig; print(sysconfig.get_path('scripts'))"):$(PATH)

PY_PLATFORM := $(shell python -c "import sysconfig; print(sysconfig.get_platform())")
PRE_COMMIT_OPTIONS := --show-diff-on-failure --color=always --all-files --hook-stage=manual

COV_TMPDIR := $(shell python -c "import tempfile; print(tempfile.mkdtemp())")

.PHONY: all
all: install

.PHONY: pre-commit
pre-commit: install
	@(pre-commit run $(PRE_COMMIT_OPTIONS) || true) | more
	@pre-commit gc

.PHONY: pylint
pylint:
	uvx pylint cx_Freeze

.PHONY: clean
clean: uninstall
	@$(MAKE) -C doc clean
	@rm -f .coverage* || true

.PHONY: install
install:
	./ci/install-tools.sh
	if ! [ -f .git/hooks/pre-commit ]; then\
		pre-commit install --install-hooks --overwrite -t pre-commit;\
	fi

.PHONY: uninstall
uninstall:
	@if [ -f .git/hooks/pre-commit ]; then\
		pre-commit clean;\
		pre-commit uninstall;\
		rm -f .git/hooks/pre-commit;\
	fi

.PHONY: upgrade
upgrade: clean install
	pre-commit autoupdate
	$(MAKE) pre-commit

.PHONY: html
html:
	@if [ -f .git/hooks/pre-commit ]; then\
		pre-commit run blacken-docs $(PRE_COMMIT_OPTIONS);\
		pre-commit run build-docs $(PRE_COMMIT_OPTIONS);\
	else\
		$(MAKE) -C doc html;\
	fi

.PHONY: htmltest
htmltest:
	$(MAKE) -C doc test

.PHONY: doc
doc:
	$(MAKE) -C doc html
	$(MAKE) -C doc epub
	$(MAKE) -C doc pdf

.PHONY: tests
tests:
	./ci/install-tools.sh --tests
	./ci/build-wheel.sh
	mkdir -p $(COV_TMPDIR)
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a samples/ $(COV_TMPDIR)/
	cp -a tests/ $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && pytest -nauto --no-cov || true

.PHONY: cov
cov:
	./ci/install-tools.sh --tests
	./ci/build-wheel.sh
	@rm -rf build/coverage_html_report
	mkdir -p $(COV_TMPDIR)
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a samples/ $(COV_TMPDIR)/
	cp -a tests/ $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && pytest -nauto --cov="cx_Freeze" || true
	coverage combine -a $(COV_TMPDIR)/.coverage
	coverage report
	coverage html

.PHONY: release
release:
	bump-my-version show-bump 2>/dev/null
	@echo "Run:"
	@echo "  bump-my-version bump <option>"
	@echo "--or--"
	@echo "  bump-my-version bump patch --new-version=X.XX.X"
	@echo "--then--"
	@echo "  git push origin `git branch --show-current` --tags"

.PHONY: release-dev
release-dev:
	if (grep "current_version" pyproject.toml | grep -q "\-dev"); then\
		bump-my-version bump --allow-dirty --no-tag build;\
	else\
		bump-my-version bump --allow-dirty --no-tag minor;\
	fi
	git log -1

=== requirements.txt ===
filelock>=3.12.3
packaging>=24
setuptools>=65.6.3,<=80.4.0
tomli>=2.0.1 ;python_version < '3.11'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'x86_64'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'i686'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'aarch64'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'armv7l'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'ppc64le'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 's390x'
dmgbuild>=1.6.1 ;sys_platform == 'darwin'
cabarchive>=0.2.4 ;sys_platform == 'win32'
cx_Logging>=3.1 ;sys_platform == 'win32' and platform_machine != 'ARM64'
lief>=0.15.1,<=0.16.5 ;sys_platform == 'win32' and platform_machine != 'ARM64'
striprtf>=0.0.26 ;sys_platform == 'win32'

=== doc/requirements.txt ===
sphinx==8.2.3 ;python_version >= '3.11'
sphinx-new-tab-link==0.8.0 ;python_version >= '3.11'
sphinx-tabs==3.4.7 ;python_version >= '3.11'
furo==2024.8.6 ;python_version >= '3.11'
myst-parser==4.0.1 ;python_version >= '3.11'

=== PKGBUILD ===
# Maintainer: Marcelo Duarte https://github.com/marcelotduarte
# Maintainer: Frode Solheim <frode@fs-uae.net>
# Contributor: Duong Pham <dthpham@gmail.com>
# Contributor: Lara Maia <dev@lara.click>

_realname=cx-freeze
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=8.3.0
pkgrel=2
pkgdesc="Creates standalone executables from Python scripts, with the same performance (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/marcelotduarte/cx_Freeze/"
msys2_references=(
  'purl: pkg:pypi/cx-freeze'
)
license=('spdx:PSF-2.0')
depends=(
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-filelock"
  "${MINGW_PACKAGE_PREFIX}-python-packaging"
  "${MINGW_PACKAGE_PREFIX}-python-pip"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-cx-logging"
  "${MINGW_PACKAGE_PREFIX}-python-lief"
  "${MINGW_PACKAGE_PREFIX}-python-cabarchive"
  "${MINGW_PACKAGE_PREFIX}-python-striprtf"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-tools"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-cov"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-mock"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-timeout"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-xdist"
)
options=(!strip)
source=(
  "https://pypi.org/packages/source/${_realname::1}/${_realname/-/_}/${_realname/-/_}-${pkgver}.tar.gz"
  "c787ff9383c6f83a45a4c7324d681a3929d63bd1.patch"
  #"${url}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
)
sha256sums=('491998d513f04841ec7967e2a3792db198597bde8a0c9333706b1f96060bdb35'
            'ab698b98d9936832a64779593a3100a078372a42e839729ad8bda477e764a5fe')

prepare() {
  cd cx_freeze-${pkgver}
  # ignore version check for setuptools and bump lief version
  sed -i 's/"setuptools>=.*"/"setuptools"/' pyproject.toml
  patch -Np1 -i ../c787ff9383c6f83a45a4c7324d681a3929d63bd1.patch

  rm -Rf "${srcdir}"/python-${_realname}-${MSYSTEM}
  cp -a "${srcdir}"/cx_freeze-${pkgver} "${srcdir}"/python-${_realname}-${MSYSTEM}
}

build() {
  cd python-${_realname}-${MSYSTEM}
  python -m build --wheel --skip-dependency-check --no-isolation
}

check() {
  cd python-${_realname}-${MSYSTEM}
  pip install cx_Freeze -f dist --no-deps --no-index
  pytest -nauto --cov="cx_Freeze"
}

package() {
  cd python-${_realname}-${MSYSTEM}
  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" dist/*.whl
  install -Dm644 LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/LICENSE.md"
}
